\name{Calculating_CI_for_model_0}
\alias{Calculating_CI_for_model_0}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating 95% Confidence Intervals for Isoform Abundance under Model 0
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the 95% confidence intervals (CI) for the isoform abundance vector (theta) of a specific gene and the gene abundance under model 0, where model 0 is difined as neither the gene nor its alternative isoforms show differential expression in all the K conditions in the study. For the detailed description of model 0 and how the 95% CI is computed, please see the reference.
}
\usage{
Calculating_CI_for_model_0(A_matrix_m0, N_vector_m0, W_vector_m0, theta_MLE_m0, loglikelihood_MLE_m0)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix_m0}{
%%     ~~Describe \code{A_matrix_m0} here~~
The sampling rate matrix under model 0.
}
  \item{N_vector_m0}{
%%     ~~Describe \code{N_vector_m0} here~~
The reads counts vector under model 0.
}
  \item{W_vector_m0}{
%%     ~~Describe \code{W_vector_m0} here~~
The sampling-rate row-sum vector under model 0.
}
  \item{theta_MLE_m0}{
%%     ~~Describe \code{theta_MLE_m0} here~~
The maximum likelihood estimation (MLE) of the isoform abundance vector (theta) under model 0, which is calculated through Expectation-Maximization (EM) approach in the "em_model0" function.
}
  \item{loglikelihood_MLE_m0}{
%%     ~~Describe \code{loglikelihood_MLE_m0} here~~
The loglikelihood under the MLE of theta in model 0.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list that contains two elements:
\item{theta_CI }{The 95% confidence interval for the isoform abundance vector of the gene under model 0.}
\item{gene_CI }{The 95% confidence interval for the gene abundance under model 0.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#The following is a toy example adopt and modified according to the single-end read data for the mouse gene "Rnpep" in section 5.1 of reference [2]. In this toy example, we assumme there are two conditions and the two conditions have the same total reads and the same reads count vector for the gene Rnpep. Therefore, we should expect the optimum model fitting this example is model 0. 

A1=matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T) #this is the sampling rate matrix of contion 1
A2=A1 #the sampling rate matrix of condtion 2 is the same as condtion 1
A_matrix = cbind(A1, A2)

N1=c(216, 10, 0) #this is the read count vector of condtion 1
N2=N1 #the read count vector of condtion 2 is the same as condtion 1
N_vector = c(N1, N2)

W1=c(12.53590, 11.88949) #this is the W vector of contion 1
W2=W1 #the W vector of condtion 2 is the same as condtion 1
W_vector = W1+W2

theta_0 = c(15.47, 2.70) #this is calculated using the em_model0 function
loglikelihood_0 = 1914.604 #this is calculated using the function log_likelihood_model0

CI_2 = Calculating_CI_for_model_0(A_matrix, N_vector, W_vector, theta_0, loglikelihood_0)
CI_2
$theta_CI
      imp_mean  CI_lower  CI_upper
[1,] 14.578357 9.7424853 18.439971
[2,]  3.720496 0.2148041  8.768426

$gene_CI
imp_mean CI_lower CI_upper 
18.29885 16.64094 20.03539 

#so the 95% CI for the joint isoform abundance vector (theta) under model 0 is: isoform 1 is (9.74, 18.44); isoform 2 is (0.21, 8.77). The 95% CI for the joint gene abundance is (16.1, 20.9). The "imp_mean" is the weighted mean of the importance sample, only given here as a reference value.

## The function is currently defined as
function (A_matrix_m0, N_vector_m0, W_vector_m0, theta_MLE_m0, 
    loglikelihood_MLE_m0) 
{
    Model_0_CI = Calculating_CI_for_theta(A_matrix_m0, N_vector_m0, 
        W_vector_m0, theta_MLE_m0, loglikelihood_MLE_m0)
    return(Model_0_CI)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
