\name{Calculating_CI_for_model_1}
\alias{Calculating_CI_for_model_1}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating 95% Confidence Intervals for Isoform Abundance under Model 1
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the 95% confidence intervals (CI) for the isoform abundance vector (theta) of a specific gene and the gene abundance under model 1. Model 1 is difined as the gene shows differential expression, but its alternative isoforms do not show differential expression in all the K conditions. For the detailed description of model 1 and how the 95% CI is computed, please see the reference.
}
\usage{
Calculating_CI_for_model_1(A_matrix_m1, N_vector_m1, W_vector_m1, theta_MLE_m1, tau_MLE_m1, log_likelihood_MLE_m1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix_m1}{
%%     ~~Describe \code{A_matrix_m1} here~~
The sampling rate matrix under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling rate matrix (A matrix) of the kth sample.
}
  \item{N_vector_m1}{
%%     ~~Describe \code{N_vector_m1} here~~
The read counts vector under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the read counts vector (N vector) of the kth sample.
}
  \item{W_vector_m1}{
%%     ~~Describe \code{W_vector_m1} here~~
The sampling-rate row-sum vector under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling-rate row-sum vector (W vector) of the kth sample.
}
  \item{theta_MLE_m1}{
%%     ~~Describe \code{theta_MLE_m1} here~~
The maximum likelihood estimation (MLE) of the basic isoform abundance vector (theta) under model 1, which is calculated through Expectation-Maximization (EM) approach in the "em_model1" function.
}
  \item{tau_MLE_m1}{
%%     ~~Describe \code{tau_MLE_m1} here~~
The maximum likelihood estimation (MLE) of the isoform abundance ratio vector (tau) under model 1, which is calculated through Expectation-Maximization (EM) approach in the "em_model1" function.
}
  \item{log_likelihood_MLE_m1}{
%%     ~~Describe \code{log_likelihood_MLE_m1} here~~
The loglikelihood under the MLE of theta and tau in model 1.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list that contains two elements:
\item{theta_CI }{The 95% confidence interval for the isoform abundance vector of the gene under model 1.}
\item{gene_CI }{The 95% confidence interval for the expression of the gene under model 1.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#the following is a toy example adopt from the single-end read data for the mouse gene "Rnpep" in section 5.1 of reference [2]. In this toy example, we assumme there are two conditions, where condition 1 is the real data for the "Rnpep" gene as describes in section 5.1 of reference [2], while condition 2 is a hypothesized condition and it has the total reads exactly the same as condition 1 and read count vector for "Rnpep" gene is twice as that of condition 1. Therefore this toy example belongs to the case of model 1 as the optimum model where only the gene shows differential expression while its isoforms do not show differential expression, and we also should expect the isoform abundance ratio vector (tau) to be ratio=(0.33, 0.67).

A1=matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T) #this is the sampling rate matrix of contion 1
A2=A1 #since the total reads of condition 2 is the same as condition 1, the sampling rate matrix of condtion 2 is also the same as condtion 1
A_matrix = list(A1, A2)

N1=c(216, 10, 0) #this is the read count vector for Rnpep in condtion 1
N2=c(432, 20, 0) #the read count vector for Rnpep in condtion 2 is twice as that in condition 1
N_vector = list(N1, N2)

W1=c(12.53590, 11.88949) #this is the W vector of contion 1
W2=W1 #since sampling rate matrix of condition 2 is the same as condition 1, the W vector of condtion 2 is also the same as condtion 1
W_vector = list(W1, W2)

#the following three lines calculate the MLE for the basic isoform abundance vector (theta) and isoform abundance vector (tau). Please see the notes and toy example of em_model1 function for details
MLE_model1 = em_model1(A_matrix, N_vector, W_vector) 
theta_MLE = MLE_model1$theta
tau_MLE = MLE_model1$ratio

#computing the loglikelihood 
loglikelihood_m1 = log_likelihood_model1(A_matrix, N_vector, W_vector, theta_MLE, tau_MLE)

CI_m1 = Calculating_CI_for_model_1(A_matrix, N_vector, W_vector, theta_MLE,  tau_MLE, loglikelihood_m1)
> CI_m1
[[1]]
[[1]]$theta_CI
      imp_mean   CI_lower  CI_upper
[1,] 15.230683 11.5665898 18.897155
[2,]  3.007886  0.1986345  6.498984

[[1]]$gene_CI
imp_mean CI_lower CI_upper 
18.23857 15.91562 20.73853 


[[2]]
[[2]]$theta_CI
      imp_mean  CI_lower CI_upper
[1,] 30.435102 23.545985 36.83375
[2,]  6.011799  0.407798 13.05048

[[2]]$gene_CI
imp_mean CI_lower CI_upper 
36.44690 33.09800 39.94774 
#so the CI_m1 contains two elements corresponding to the CI estimation for the two conditions in this example. In condition 1, the 95% CI of theta for the 1st isoform is (11.57, 18.90) and the 95% CI of theta for the 2nd isoform is (0.20, 6.50); the 95% CI for the gene is (15.92, 20.74); In condition 2, the 95% CI of theta for the 1st isoform is (23.55, 36.83) and the 95% CI of theta for the 2nd isoform is (0.41, 13.05); the 95% CI for the gene is (33.10, 39.95).The "imp_mean" is the weighted mean of the importance sample, only given here as a reference value.

## The function is currently defined as
function (A_matrix_m1, N_vector_m1, W_vector_m1, theta_MLE_m1, 
    tau_MLE_m1, log_likelihood_MLE_m1) 
{
    K_conditions = length(W_vector_m1)
    dimention_theta = length(theta_MLE_m1)
    N_vector_temp = unlist(lapply(N_vector_m1, na.exclude))
    A_matrix_temp = do.call(cbind, lapply(A_matrix_m1, na.exclude))
    Model_1_CI = list()
    if (is.logical(A_matrix_temp) && is.logical(N_vector_temp)) {
        theta_result = matrix(rep(0, times = 3 * dimention_theta), 
            ncol = 3, nrow = dimention_theta)
        gene_result = c(0, 0, 0)
        colnames(theta_result) = c("imp_mean", "CI_lower", "CI_upper")
        names(gene_result) = c("imp_mean", "CI_lower", "CI_upper")
        for (k in 1:K_conditions) {
            Model_1_CI[[k]] = list(theta_CI = theta_result, gene_CI = gene_result)
        }
        return(Model_1_CI)
    }
    else if (any(is.na(theta_MLE_m1))) {
        Model_1_CI = list(theta_CI = NA, gene_CI = NA)
        return(Model_1_CI)
    }
    else {
        position_of_zero_counts = NULL
        for (k in 1:K_conditions) {
            if (any(is.na(A_matrix_m1[[k]]))) {
                position_of_zero_counts = append(position_of_zero_counts, 
                  k)
            }
        }
        if (length(position_of_zero_counts) > 0) {
            A_matrix_m1_new = A_matrix_m1[!is.na(A_matrix_m1)]
            N_vector_m1_new = N_vector_m1[!is.na(N_vector_m1)]
            tau_MLE_m1_new = tau_MLE_m1[-position_of_zero_counts]
            W_vector_m1_new = W_vector_m1[-position_of_zero_counts]
        }
        else {
            A_matrix_m1_new = A_matrix_m1
            N_vector_m1_new = N_vector_m1
            tau_MLE_m1_new = tau_MLE_m1
            W_vector_m1_new = W_vector_m1
        }
        fisher_I_matrix = fisher_information_model1(A_matrix_m1_new, 
            W_vector_m1_new, theta_MLE_m1, tau_MLE_m1_new)
        eigen_fisher_I = eigen(fisher_I_matrix, symmetric = T, 
            only.values = T)$values
        r_condition = rcond(fisher_I_matrix)
        if (any(eigen_fisher_I <= 0) || r_condition < 1e-09) {
            Model_1_CI = list(theta_CI = NA, gene_CI = NA)
            return(Model_1_CI)
        }
        num_free_tau = length(tau_MLE_m1_new) - 1
        dimention_para = dimention_theta + num_free_tau
        C_matrix = solve(fisher_I_matrix)
        C_matrix = 4 * C_matrix
        C_matrix = (C_matrix + t(C_matrix))/2
        N_samp = 50000
        mean_imp = c(theta_MLE_m1, tau_MLE_m1_new[0:num_free_tau])
        sigma_imp = C_matrix
        theta_tau_imp_samp = rmvt(N_samp, sigma = sigma_imp, 
            delta = mean_imp, df = 5)
        theta_tau_imp_density = dmvt(theta_tau_imp_samp, delta = mean_imp, 
            sigma = sigma_imp, log = FALSE)
        if (num_free_tau >= 1) {
            tau_imp_lastcol = 1 - rowSums(as.matrix(theta_tau_imp_samp[, 
                (dimention_theta + 1):(dimention_para)]))
        }
        else {
            tau_imp_lastcol = rep(1, times = 50000)
        }
        theta_tau_imp_samp = cbind(theta_tau_imp_samp, tau_imp_lastcol)
        proposal_samp_weight = calculating_imp_weight(theta_tau_imp_samp, 
            theta_tau_imp_density, A_matrix_m1, N_vector_m1, 
            W_vector_m1, log_likelihood_MLE_m1, model_select = 1)
        proposal_samp_new = proposal_samp_weight$proposal_samp_new
        weight_norm = proposal_samp_weight$weight_norm
        gene_imp_sample = list()
        theta_samp = as.matrix(proposal_samp_new[, 1:dimention_theta])
        tau_samp = as.matrix(proposal_samp_new[, (dimention_theta + 
            1):(dimention_theta + num_free_tau + 1)])
        num_na = 0
        for (k in 1:K_conditions) {
            theta_result = matrix(rep(0, times = 3 * dimention_theta), 
                ncol = 3, nrow = dimention_theta)
            if (!is.na(match(k, position_of_zero_counts))) {
                gene_result = c(0, 0, 0)
                num_na = num_na + 1
            }
            else {
                theta_samp_k_condition = as.matrix(theta_samp * 
                  tau_samp[, (k - num_na)])
                for (i in 1:dimention_theta) {
                  theta_result[i, ] = imp_estimate(theta_samp_k_condition[, 
                    i], weight_norm)
                }
                gene_imp_sample = rowSums(theta_samp_k_condition)
                gene_result = imp_estimate(gene_imp_sample, weight_norm)
            }
            colnames(theta_result) = c("imp_mean", "CI_lower", 
                "CI_upper")
            names(gene_result) = c("imp_mean", "CI_lower", "CI_upper")
            Model_1_CI[[k]] = list(theta_CI = theta_result, gene_CI = gene_result)
        }
        return(Model_1_CI)
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
