\name{Calculating_CI_for_model_2}
\alias{Calculating_CI_for_model_2}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating 95% Confidence Intervals for Isoform Abundance under Model 2
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the 95% confidence intervals (CI) for the isoform abundance vector (theta) of a specific gene and the gene abundance under model 2, where  model 2 is difined as both the gene and its alternative isoforms show differential expression in all the K conditions. For the detailed description of model 2 and how the 95% CI is computed, please see the reference.
}
\usage{
Calculating_CI_for_model_2(A_matrix_m2, N_vector_m2, W_vector_m2, theta_MLE_m2, log_likelihood_MLE_m2)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix_m2}{
%%     ~~Describe \code{A_matrix_m2} here~~
The sampling rate matrix under model 2, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling rate matrix (A matrix) of the kth sample.
}
  \item{N_vector_m2}{
%%     ~~Describe \code{N_vector_m2} here~~
The read counts vector under model 2, which is a list of length K (K is the number of samples in the study). The kth element in this list is the read counts vector (N vector) of the kth sample.
}
  \item{W_vector_m2}{
%%     ~~Describe \code{W_vector_m2} here~~
The sampling-rate row-sum vector under model 2, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling-rate row-sum vector (W vector) of the kth sample.
}
  \item{theta_MLE_m2}{
%%     ~~Describe \code{theta_MLE_m2} here~~
The maximum likelihood estimation (MLE) of the isoform abundance vector (theta) under model 2, which is a K*I matrix (K is the number of the conditions/samples in the study; I is the number of isoforms of the gene). 
}
  \item{log_likelihood_MLE_m2}{
%%     ~~Describe \code{log_likelihood_MLE_m2} here~~
The loglikelihood under MLE of theta in model 2.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list of length K (K is the number of conditions in the study), and the kth element in the list is the estimation of the 95% confidence intervals for the isoform abundance vector (theta) and gene abundance vector in the kth condition, which is also a list containing the following two elements:
\item{theta_CI }{The 95% confidence intervals for the isoform abundance vector of the gene under model 2.}
\item{gene_CI }{The 95% confidence intervals for the gene abundance under model 2.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#the following is a toy example adopt from the single-end read data for the mouse gene "Rnpep" in section 5.1 of reference [2]. In this toy example, we assumme there are two conditions, where condition 1 is the real data for the "Rnpep" gene as describes in section 5.1 of reference [2], while condition 2 is a hypothesized condition and it has the total reads exactly the same as condition 1, but the read count vector for "Rnpep" gene quite different from that of condition 1. Therefore model 2 is the optimum model that fits this toy example where both the gene and its alternative isoforms show differential expression.

A1=matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T)#this is the sampling rate matrix of contion 1
A2=A1 #since the total reads of condition 2 is the same as condition 1, the sampling rate matrix of condtion 2 is also the same as condtion 1
A_matrix = list(A1, A2)

N1=c(216, 10, 0)#this is the read count vector for Rnpep in condtion 1
N2=c(216, 0, 60)#we gives the read count vector for Rnpep in condtion 2 to make model 2 fit this example.
N_vector = list(N1, N2)

W1=c(12.53590, 11.88949)#this is the W vector of contion 1
W2=W1#since sampling rate matrix of condition 2 is the same as condition 1, the W vector of condtion 2 is also the same as condtion 1
W_vector = list(W1, W2)

#under model 2, the two conditions are independent. Therefore the MLE of isoform abundance vectors (theta) of the two conditions are estimated independently using the function em_model0
theta_MLE_1 = em_model0(A1, N1, W1)
theta_MLE_2 = em_model0(A2, N2, W2)
theta_MLE = rbind(theta_MLE_1, theta_MLE_2)

loglikelihood = c( log_likelihood_model0(A1, N1, W1, theta_MLE_1), log_likelihood_model0(A2, N2, W2, theta_MLE_2) )

CI_m2 = Calculating_CI_for_model_2(A_matrix, N_vector, W_vector, theta_MLE, loglikelihood)
CI_m2

[[1]]
[[1]]$theta_CI
      imp_mean  CI_lower CI_upper
[1,] 13.945174 7.8943036 18.85228
[2,]  4.472114 0.2200424 10.83514

[[1]]$gene_CI
imp_mean CI_lower CI_upper 
18.41729 16.09501 20.91807 


[[2]]
[[2]]$theta_CI
        imp_mean     CI_lower    CI_upper
[1,]  0.01373763 6.940568e-04  0.02402859
[2,] 23.15224831 2.029625e+01 25.75750638

[[2]]$gene_CI
imp_mean CI_lower CI_upper 
23.16599 20.30584 25.76197 

#so the CI_m2 contains two elements corresponding to the CI estimation for the two conditions in this example. In condition 1, the 95% CI of theta for the 1st isoform is (7.89, 18.85) and the 95% CI of theta for the 2nd isoform is (0.22, 10.84); the 95% CI for the gene is (16.09, 20.92); In condition 2, the 95% CI of theta for the 1st isoform is (6.94e-4, 0.024) and the 95% CI of theta for the 2nd isoform is (20.30, 25.76); the 95% CI for the gene is (20.31, 25.76). The "imp_mean" is the weighted mean of the importance sample, only given here as a reference value.

## The function is currently defined as
function (A_matrix_m2, N_vector_m2, W_vector_m2, theta_MLE_m2, 
    log_likelihood_MLE_m2) 
{
    K_conditions = length(W_vector_m2)
    Model_2_CI = list()
    for (k in 1:K_conditions) {
        Model_2_CI[[k]] = Calculating_CI_for_theta(A_matrix_m2[[k]], 
            N_vector_m2[[k]], W_vector_m2[[k]], theta_MLE_m2[k, 
                ], log_likelihood_MLE_m2[k])
    }
    return(Model_2_CI)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
