\name{Calculating_CI_for_theta}
\alias{Calculating_CI_for_theta}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating 95% Confidence Intervals for Isoform Abundance
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the 95% confidence intervals for isoform abundance (theta) of a gene using a Baysian approach and importance sampling method. For a detailed description of the method, please see the reference.
}
\usage{
Calculating_CI_for_theta(A_matrix, N_vector, W_vector, theta_MLE, loglikelihood_MLE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
The sampling rate matrix for of the gene. Please see the reference for a detailed description.
}
  \item{N_vector}{
%%     ~~Describe \code{N_vector} here~~
The read count vector for the gene. Please see the reference for a detailed description.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector for the gene. Please see the reference for a detailed description.
}
  \item{theta_MLE}{
%%     ~~Describe \code{theta_MLE} here~~
The maximum likelihood estimation (MLE) of isoform abundance vector (theta), which is calculated through Expectation-Maximization (EM) approach.
}
  \item{loglikelihood_MLE}{
%%     ~~Describe \code{loglikelihood_MLE} here~~
The loglikelihood under theta_MLE
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list that contains two elements:
\item{theta_CI }{The 95% confidence interval for the expression of each isoform of a specific gene under model 0.}
\item{gene_CI }{The 95% confidence interval for the expression of the gene under model 0.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#This toy example is adopt from the single-end read data for the mouse gene "Rnpep" in section 5.1 of reference [2], where the gene Rnpep has two isoforms. In this example, there are only one condition. The sampling rate matrix A, the read count vector N and the sampling-rate row-sum vector W is given by the user. Please see the reference for a detailed description of A_matrix, N_vector and W_vector.

A = matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T)
N = c(216, 10, 0)
W = c(12.53590, 11.88949)
theta_MLE = c(15.47, 2.70) #this is calculated using the em_model0 function
loglikelihood = 957.3022 #this is calculated using the log_likelihood_model0 function

CI_1 = Calculating_CI_for_theta(A, N, W, theta_MLE, loglikelihood)
CI_1
$theta_CI
      imp_mean  CI_lower CI_upper
[1,] 13.940147 7.9271877 18.88192
[2,]  4.470964 0.2309204 10.78919

$gene_CI
imp_mean CI_lower CI_upper 
18.41111 16.10687 20.90137 

#so the 95% CI of theta for the 1st isoform is (7.9, 18.9) and the 95% CI of theta for the 2nd isoform is (0.23, 10.8); the 95% CI for the gene is (16.1, 20.9). The "imp_mean" is the weighted mean of the importance sample, only given here as a reference value.

## The function is currently defined as
function (A_matrix, N_vector, W_vector, theta_MLE, loglikelihood_MLE) 
{
    dimention_theta = length(theta_MLE)
    if (any(is.na(A_matrix)) && any(is.na(N_vector))) {
        theta_result = matrix(rep(0, times = 3 * dimention_theta), 
            ncol = 3, nrow = dimention_theta)
        gene_result = c(0, 0, 0)
        colnames(theta_result) = c("imp_mean", "CI_lower", "CI_upper")
        names(gene_result) = c("imp_mean", "CI_lower", "CI_upper")
        CI_result = list(theta_CI = theta_result, gene_CI = gene_result)
        return(CI_result)
    }
    else if (any(is.na(A_matrix)) == F && any(is.na(N_vector)) == 
        F) {
        fisher_I_matrix = fisher_information_model0(A_matrix, 
            W_vector, theta_MLE)
        eigen_fisher_I = eigen(fisher_I_matrix, symmetric = T, 
            only.values = T)$values
        r_condition = rcond(fisher_I_matrix)
        if (any(eigen_fisher_I <= 0) || r_condition < 1e-09) {
            CI_result = list(theta_CI = NA, gene_CI = NA)
            return(CI_result)
        }
        C_matrix = solve(fisher_I_matrix)
        C_matrix = 4 * C_matrix
        C_matrix = (C_matrix + t(C_matrix))/2
        N_samp = 50000
        theta_proposal_samp = rmvt(N_samp, delta = theta_MLE, 
            sigma = C_matrix, df = 5)
        theta_proposal_density = dmvt(theta_proposal_samp, delta = theta_MLE, 
            sigma = C_matrix, df = 5, log = FALSE)
        theta_samp_weight = calculating_imp_weight(theta_proposal_samp, 
            theta_proposal_density, A_matrix, N_vector, W_vector, 
            loglikelihood_MLE, model_select = 0)
        theta_proposal_samp_new = theta_samp_weight$proposal_samp_new
        weight_norm = theta_samp_weight$weight_norm
        theta_result = matrix(rep(0, times = 3 * dimention_theta), 
            ncol = 3, nrow = dimention_theta)
        for (i in 1:dimention_theta) {
            theta_result[i, ] = imp_estimate(theta_proposal_samp_new[, 
                i], weight_norm)
        }
        gene_imp_sample = rowSums(subset(theta_proposal_samp_new, 
            select = -imp_density))
        gene_imp_estimation = imp_estimate(gene_imp_sample, weight_norm)
        colnames(theta_result) = c("imp_mean", "CI_lower", "CI_upper")
        names(gene_imp_estimation) = c("imp_mean", "CI_lower", 
            "CI_upper")
        CI_result = list(theta_CI = theta_result, gene_CI = gene_imp_estimation)
        return(CI_result)
    }
    else {
        print("There is something wrong with either the A_matrix or N_vector. One of them is NULL, but the other is not NULL.")
        CI_result = list(theta_CI = NA, gene_CI = NA)
        return(CI_result)
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
