\name{calculating_imp_weight}
\alias{calculating_imp_weight}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating the importance weight for the importance sample
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the normalized importance weight for the importance sample.
}
\usage{
calculating_imp_weight(imp_samp, imp_density, A_matrix, N_vector, W_vector, loglikelihood_MLE, model_select)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{imp_samp}{
%%     ~~Describe \code{imp_samp} here~~
this is a dataframe of the importance sample of isoform abundance (which is drawn from the multivariate t-distribution).
}
  \item{imp_density}{
%%     ~~Describe \code{imp_density} here~~
this is the density matching the importance sample of isoform abundance (the density of the multivariate t-distribution).
}
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
this is the sampling rate matrix. See the reference for a detailed description of sampling rate matrix.
}
  \item{N_vector}{
%%     ~~Describe \code{N_vector} here~~
this is the read count vector. See the reference for a detailed description of read count vector.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector. See the reference for a detailed description of sampling-rate row-sum vector.
}
  \item{loglikelihood_MLE}{
%%     ~~Describe \code{loglikelihood_MLE} here~~
The loglikelihood under the maximum likelihood estimation (MLE).
}
  \item{model_select}{
%%     ~~Describe \code{model_select} here~~
this is a numerical value of either 0 or 1. If the value is 0, then the function calculates the normalized importance weights of model 0; if the value is 1, then the function calculates the normalized importance weights of model 1.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns to a list containing the following elements:
\item{proposal_samp_new}{this is a dataframe of the importance samples.}
\item{weight_norm}{this is a vector of the importance weights corresponding to the importance samples.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (imp_samp, imp_density, A_matrix, N_vector, W_vector, 
    loglikelihood_MLE, model_select) 
{
    N_samp = 50000
    row_min_of_imp_samp = apply(imp_samp, MARGIN = 1, FUN = min)
    proposal_samp = data.frame(imp_samp, imp_density, row_min_of_imp_samp)
    greater_zero_samp = subset(proposal_samp, row_min_of_imp_samp >= 
        0, select = -row_min_of_imp_samp)
    if (model_select == 0) {
        log_imp_samp = log_likelihood_model0(A_matrix, N_vector, 
            W_vector, subset(greater_zero_samp, select = -imp_density))
    }
    if (model_select == 1) {
        num_tau = length(lapply(A_matrix, na.exclude))
        dimention_theta = length(W_vector[[1]])
        theta_imp_samp_greaterzero = greater_zero_samp[, 1:dimention_theta]
        tau_imp_samp_greaterzero = greater_zero_samp[, (dimention_theta + 
            1):(dimention_theta + num_tau)]
        log_imp_samp = log_likelihood_model1(A_matrix, N_vector, 
            W_vector, theta_imp_samp_greaterzero, tau_imp_samp_greaterzero)
    }
    likelihood_greater_zero = exp(as.vector(log_imp_samp) - loglikelihood_MLE)
    smaller_zero_samp = subset(proposal_samp, row_min_of_imp_samp < 
        0, select = -row_min_of_imp_samp)
    likelihood_smaller_zero = rep(0, times = (N_samp - length(likelihood_greater_zero)))
    proposal_samp_new = rbind(greater_zero_samp, smaller_zero_samp)
    likelihood_sample = c(likelihood_greater_zero, likelihood_smaller_zero)
    weight = likelihood_sample/proposal_samp_new$imp_density
    weight_norm = weight/sum(weight)
    return(list(proposal_samp_new = proposal_samp_new, weight_norm = weight_norm))
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
