\name{em_model1}
\alias{em_model1}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating MLE of Alternative Isoform Abundance
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculate the maximum likelihood estimation (MLE) for the alternative isoform abundance of a specific gene under model 1 through the expectation-maximization (EM) algorithm, where model 1 is defined as the gene shows differential expression, but its alternative isoforms do not show differential expression in all the conditions/samples. For detailed descriptions of how the models are difined, how the isoform abundance is calculated, please see the references.
}
\usage{
em_model1(A_matrix, N_vector, W_vector)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
This is a list containing all the collapsed sampling rate matrices (A matrices) of all the K conditions. See the references for a detailed description of sampling rate matrix.
}
  \item{N_vector}{
%%     ~~Describe \code{N_vector} here~~
This is a list containing all the collapsed read count vectors (N vectors) of all the K conditions. See the references for a detailed description of read count vector.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
This is a list containing all the sampling-rate row-sum vectors (N vectors) of all the K conditions. See the references for a detailed description of W vector.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list containing two elements:
\item{theta}{this is the basic isoform abundance vector (\theta) under model 1.}
\item{ratio}{this is the isoform abundance ratio vector (\tau) under model 1.}
Under model 1, the isoform abundance vectors of each conditions equal to the outer product of \theta and \tau. See the reference for a detailed description.
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.
#the following is a toy example adopt from the single-end read data for the mouse gene "Rnpep" in section 5.1 of reference [2]. In this toy example, we assumme there are two conditions, where condition 1 is the real data for the "Rnpep" gene as describes in section 5.1 of reference [2], while condition 2 is a hypothesized condition and it has the total reads exactly the same as condition 1 and read count vector for "Rnpep" gene is twice as that of condition 1. Therefore this toy example belongs to the case of model 1 as the optimum model where only the gene shows differential expression while its isoforms do not show differential expression, and we should expect the isoform abundance ratio vector (tau) to be ratio=(0.33, 0.67).

A1=matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T)#this is the sampling rate matrix of contion 1
A2=A1 #since the total reads of condition 2 is the same as condition 1, the sampling rate matrix of condtion 2 is also the same as condtion 1
A_matrix = list(A1, A2)

N1=c(216, 10, 0)#this is the read count vector for Rnpep in condtion 1
N2=c(432, 20, 0)#the read count vector for Rnpep in condtion 2 is twice as that in condition 1
N_vector = list(N1, N2)

W1=c(12.53590, 11.88949)#this is the W vector of contion 1
W2=W1#since sampling rate matrix of condition 2 is the same as condition 1, the W vector of condtion 2 is also the same as condtion 1
W_vector = list(W1, W2)

MLE_model1=em_model1(A_matrix, N_vector, W_vector)
MLE_model1
$theta
          [,1]
[1,] 46.406694
[2,]  8.095413

$ratio
[1] 0.3333333 0.6666667
#therefore the MLE of the basic isoform abundance vector under model 1 is (46.41, 8.10) and MLE of isoform abundance ratio vector under model 1 is c(0.33, 0.67).

#if you want to get the isoform abundance vector matrix under model 1, use the code:
theta_each_condition = outer(MLE_model1$ratio, MLE_model1$theta)
theta_each_condition
      [,1]        [,2]
[1,] 15.4689 2.698471
[2,] 30.9378 5.396942
#so the isoform abundance vector (theta) of condition 1 is the 1st row of this matrix, (15.47, 2.70), and the isoform abundance vector of condition 2 is the second row of this matrix, (30.94, 5.40).

## The function is currently defined as
function (A_matrix, N_vector, W_vector) 
{
    K_conditions = length(W_vector)
    num_isoform = length(W_vector[[1]])
    N_vector_temp = unlist(lapply(N_vector, na.exclude))
    A_matrix_temp = do.call(cbind, lapply(A_matrix, na.exclude))
    if (is.logical(A_matrix_temp) && is.logical(N_vector_temp)) {
        theta = rep(0, times = num_isoform)
        ratio = rep(0, times = K_conditions)
        estimate = list(theta = theta, ratio = ratio)
        return(estimate)
    }
    else if (is.logical(A_matrix_temp) == F && is.logical(N_vector_temp) == 
        F) {
        theta_old = rep(1/num_isoform, times = num_isoform)
        theta_old_previous = rep(0, times = num_isoform)
        num_iter = 0
        ratio = rep(0, times = K_conditions)
        n_i_j = list()
        while (sum(abs(theta_old - theta_old_previous)) > 1e-06) {
            num_iter = num_iter + 1
            for (k in 1:K_conditions) {
                if (any(is.na(A_matrix[[k]])) == F && any(is.na(N_vector[[k]])) == 
                  F) {
                  ratio[k] = sum(N_vector[[k]])/sum(W_vector[[k]] * 
                    theta_old)
                  n_i_j[[k]] = matrix(c(t(tcrossprod(theta_old, 
                    N_vector[[k]]))) * c(t(A_matrix[[k]]))/c(crossprod(theta_old, 
                    A_matrix[[k]])), nrow = num_isoform, byrow = T)
                }
                else if ((any(is.na(A_matrix[[k]])) == T && any(is.na(N_vector[[k]])) == 
                  F) || (any(is.na(A_matrix[[k]])) == F && any(is.na(N_vector[[k]])) == 
                  T)) {
                  k_error = k
                  estimate = list(theta = NA, ratio = NA, k_error = k_error)
                  return(estimate)
                }
            }
            theta_new = rowSums(do.call(cbind, n_i_j))/crossprod(do.call(rbind, 
                W_vector), ratio)
            theta_old_previous = theta_old
            theta_old = theta_new
        }
        theta = theta_new * sum(ratio)
        ratio = ratio/sum(ratio)
        estimate = list(theta = theta, ratio = ratio)
        return(estimate)
    }
    else {
        print("There is something wrong with either the A_matrix or N_vector. One of them is NA, but the other is not NA.")
        estimate = list(theta = NA, ratio = NA)
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
