\name{fisher_information_model0}
\alias{fisher_information_model0}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating the fisher information matrix under model 0.
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the fisher information matrix under model 0, where model 0 is defined as neither the gene nor its alternative isoforms show differential expression in all the K conditions. The fisher information matrix is used when calculating 95% confidence intervals of isoform abundance.
}
\usage{
fisher_information_model0(A_matrix, W_vector, theta)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
The collapsed sampling rate matrix for a gene in one sample. This matrix is generated in one of the rseq output files with the extension ".sampling_rates" and is automatically read into a matrix in R through calling the function "read_file" of this "rdiff" package. See the references for a detailed description of sampling rate matrix.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector for a gene in one sample, whose element is the sum of the corresponding row of the full sampling rate matrix (A_matrix). This vector is generated in one of the rseq output files with the extension ".sampling_rates" and is automatically read into a vector in R through calling the function "read_file" in this "rdiff" package. See the references for a detailed description of sampling-rate row-sum vector.
}
  \item{theta}{
%%     ~~Describe \code{theta} here~~
The isoform abundance vector (\theta) under model 0.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a matrix, which is exactly the fisher information matrix under model 0.
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (A_matrix, W_vector, theta) 
{
    A_matrix = as.matrix(A_matrix)
    I = length(theta)
    J = dim(A_matrix)[2]
    epsilon = 1e-10
    theta_new = theta + epsilon
    fisher_I = A_matrix \%*\% diag(as.vector(1/crossprod(A_matrix, 
        theta_new)), nrow = J, ncol = J) \%*\% t(A_matrix)
    if (det(fisher_I) < 1e-06) {
        diag(fisher_I) = diag(fisher_I) + (W_vector^2)/(I * sum(W_vector * 
            theta_new))
    }
    return(fisher_I)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
