\name{fisher_information_model1}
\alias{fisher_information_model1}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating the fisher information matrix under model 1.
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the fisher information matrix under model 1, where model 1 is defined as the gene shows differential expression, but its alternative isoforms do not show differential expression in all the K conditions The fisher information matrix is used when calculating 95% confidence intervals of isoform abundance.
}
\usage{
fisher_information_model1(A_matrix, W_vector, theta, tau)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
The sampling rate matrix under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling rate matrix (A matrix) of the kth sample.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling-rate row-sum vector (W vector) of the kth sample.
}
  \item{theta}{
%%     ~~Describe \code{theta} here~~
The basic isoform abundance vector under model 1.
}
  \item{tau}{
%%     ~~Describe \code{tau} here~~
The isoform abundance ratio vector under model 1.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a matrix, which is exactly the fisher information matrix under model 1.
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (A_matrix, W_vector, theta, tau) 
{
    K_conditions = length(tau)
    dimention_theta = length(theta)
    epsilon = 1e-10
    theta_new = theta + epsilon
    tau_new = tau + epsilon
    fisher_I_theta = list()
    diag_tau = list()
    fisher_I_theta_tau = matrix(rep(0, times = dimention_theta * 
        (K_conditions - 1)), nrow = dimention_theta)
    for (k in 1:K_conditions) {
        A_k = as.matrix(A_matrix[[k]])
        J = dim(A_k)[2]
        fisher_I_theta[[k]] = tau_new[k] * (A_k \%*\% diag(as.vector(1/crossprod(A_k, 
            theta_new)), nrow = J, ncol = J) \%*\% t(A_k))
        W_k = W_vector[[k]]
        diag(fisher_I_theta[[k]]) = diag(fisher_I_theta[[k]]) + 
            (W_k^2)/(dimention_theta * sum(W_k * theta_new))
        if (k < K_conditions) {
            diag_tau[[k]] = sum(W_vector[[k]] * theta_new)/tau_new[k] + 
                sum(W_vector[[K_conditions]] * theta_new)/tau_new[K_conditions]
            fisher_I_theta_tau[, k] = W_vector[[k]] - W_vector[[K_conditions]]
        }
    }
    fisher_I_theta = Reduce("+", fisher_I_theta)
    if (K_conditions == 1) {
        fisher_I = fisher_I_theta
    }
    else {
        fisher_I_tau = matrix(rep(sum(crossprod(A_matrix[[k]], 
            theta_new)), (K_conditions - 1) * (K_conditions - 
            1)), nrow = (K_conditions - 1))
        diag(fisher_I_tau) = unlist(diag_tau)
        fisher_I_up = cbind(fisher_I_theta, fisher_I_theta_tau)
        fisher_I_down = cbind(t(fisher_I_theta_tau), fisher_I_tau)
        fisher_I = rbind(fisher_I_up, fisher_I_down)
    }
    return(fisher_I)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
