\name{likelihood_ratio_test}
\alias{likelihood_ratio_test}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Perform likelihood ratio test
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function perform the likelihood ratio test for the three models of isoform differential expression, where model 0 is difined as neither the gene nor its alternative isoforms show differential expression in all the K conditions; model 1 is defined as the gene show differential expression, but its alternative isoforms do not show differential expression in all the K conditions; model 2 is defined as both the gene and its alternative isoforms show differential expression in all the K conditions. For a detailed description of the three models and how the loglikelihood functions are calculated under the three models, please see the reference.
}
\usage{
likelihood_ratio_test(loglikelihood_MLE_m0, loglikelihood_MLE_m1, loglikelihood_MLE_m2, K_conditions, num_isoform)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{loglikelihood_MLE_m0}{
%%     ~~Describe \code{loglikelihood_MLE_m0} here~~
This is the loglikelihood value for the maximum likelihood estimation (MLE) under model 0.
}
  \item{loglikelihood_MLE_m1}{
%%     ~~Describe \code{loglikelihood_MLE_m1} here~~
This is the loglikelihood value for the maximum likelihood estimation (MLE) under model 1.
}
  \item{loglikelihood_MLE_m2}{
%%     ~~Describe \code{loglikelihood_MLE_m2} here~~
This is the loglikelihood value for the maximum likelihood estimation (MLE) under model 2.
}
  \item{K_conditions}{
%%     ~~Describe \code{K_conditions} here~~
The number of conditions/samples in the study.
}
  \item{num_isoform}{
%%     ~~Describe \code{num_isoform} here~~
The number of isoforms for the gene.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
This function returns a list containing two elements:
\item{opt_model}{This is a character containing which model the likelihood ratio test supports for.}
\item{p_value}{This is a numerical vector containing the p-values of the likelihood ratio test.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#this function is mainly internally called by isoform_estimation function to perform the likelihood ratio test (LRT). The user can also use this function to perform the LRT test for a single gene by giving the loglikelihood under model 0, 1 and 2. The following example illustrates the LRT test for the gene in the toy example of the em_model1 function, where model 1 is the optimum model fitting the data. Please see the toy example of the em_model1 function for the A matrix, N vector and W vector.

loglikelihood_model0 = 3146.812 #this value can be calculated by the function log_likelihood_model0

loglikelihood_model1 = 3185.209 #this value can be calculated by the function log_likelihood_model1

log_likelihood_model2 = 3185.209 #this value can be calculated by treating the two conditions as independent and calling the function log_likelihood_model0 twice to calculate the loglikelihood under each condition, and sum up the two loglikelihoods

LRT_result = likelihood_ratio_test(loglikelihood_model0, loglikelihood_model1, log_likelihood_model2, K_conditions=2, num_isoform=2)
> LRT_result
$opt_model
[1] "model_1"

$p_value
[1] 0.0000000 0.0000000 0.9996651
#so the LRT_result shows that the optimum model fitting the data is model 1, and the p-value for comparing model 1 vs. model 0 is 0; the p-value for comparing model 2 vs. model 0 is 0; the p-value for comparing model 2 vs. model 1 is 0.9996651. Thus at 0.05 level, model 1 is the optimum model. This should be expected, since in this example we on purpose make condition 2 has the total reads exactly the same as condition 1 and read count vector for "Rnpep" gene is twice as that of condition 1.


## The function is currently defined as
function (loglikelihood_MLE_m0, loglikelihood_MLE_m1, loglikelihood_MLE_m2, 
    K_conditions, num_isoform) 
{
    LRT_model1_vs_model0 = (-2) * (loglikelihood_MLE_m0 - loglikelihood_MLE_m1)
    P_model1_vs_model0 = 1 - pchisq(LRT_model1_vs_model0, df = (K_conditions - 
        1))
    LRT_model2_vs_model0 = (-2) * (loglikelihood_MLE_m0 - loglikelihood_MLE_m2)
    P_model2_vs_model0 = 1 - pchisq(LRT_model2_vs_model0, df = (K_conditions - 
        1) * num_isoform)
    p_value = c(P_model1_vs_model0, P_model2_vs_model0)
    if (P_model1_vs_model0 >= 0.05 && P_model2_vs_model0 >= 0.05) {
        opt_model = "model_0"
        return(list(opt_model = opt_model, p_value = p_value))
    }
    if (P_model1_vs_model0 >= 0.05 && P_model2_vs_model0 < 0.05) {
        opt_model = "model_2"
        return(list(opt_model = opt_model, p_value = p_value))
    }
    if (P_model1_vs_model0 < 0.05 && P_model2_vs_model0 >= 0.05) {
        opt_model = "model_1"
        return(list(opt_model = opt_model, p_value = p_value))
    }
    if (P_model1_vs_model0 < 0.05 && P_model2_vs_model0 < 0.05) {
        LRT_model2_vs_model1 = (-2) * (loglikelihood_MLE_m1 - 
            loglikelihood_MLE_m2)
        P_model2_vs_model1 = 1 - pchisq(LRT_model2_vs_model1, 
            df = (K_conditions - 1) * (num_isoform - 1))
        p_value = c(p_value, P_model2_vs_model1)
        if (P_model2_vs_model1 >= 0.05) {
            opt_model = "model_1"
            return(list(opt_model = opt_model, p_value = p_value))
        }
        else {
            opt_model = "model_2"
            return(list(opt_model = opt_model, p_value = p_value))
        }
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
