\name{log_likelihood_model0}
\alias{log_likelihood_model0}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Calculate the loglikelihood under model 0
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the loglikelihood under model 0, where model 0 is defined as neither the gene nor its alternative isoforms show differential expression in all the K conditions in the study. For a detailed description of model 0 and the fomular for the loglikelihood function, please see the reference.
}
\usage{
log_likelihood_model0(A_matrix, N_vector, W_vector, theta)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
The sampling rate matrix under model 0.
}
  \item{N_vector}{
%%     ~~Describe \code{N_vector} here~~
The reads counts vector under model 0.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector under model 0.
}
  \item{theta}{
%%     ~~Describe \code{theta} here~~
The isoform abundance vector under model 0.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns either a numerical value or a numerical vector, depends on theta. If theta is a vector, then this function returns a numerical value. If theta is a matrix, for example, theta might be an importance sample for calculating confidence intervals under model 0. In this case, theta is a N*I matrix, where N is the number of samples and I is the number of isoforms of the gene, then this function return a vector of length N.
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.
#The following is an example adopt from reference [2]. Please see the reference for a detailed description of A_matrix, N_vector, W_vector and theta_MLE.
A_matrix = matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T)
N_vector = c(216, 10, 0)
W_vector = c(12.53590, 11.88949)
theta_MLE = c(15.47, 2.70)
loglikelihood = log_likelihood_model0(A_matrix, N_vector, W_vector, theta_MLE)
#the result is loglikelihood = 957.3022

## The function is currently defined as
function (A_matrix, N_vector, W_vector, theta) 
{
    I = length(W_vector)
    theta = matrix(as.matrix(theta), ncol = I)
    nrow_theta = dim(theta)[2]
    if (any(is.na(A_matrix)) && any(is.na(N_vector))) {
        loglikelihood = rep(0, times = nrow_theta)
        return(loglikelihood)
    }
    else if (any(is.na(A_matrix)) == F && any(is.na(N_vector)) == 
        F) {
        epsilon = 1e-10
        theta_new = theta + epsilon
        loglikelihood = -crossprod(W_vector, t(theta_new)) + 
            crossprod(N_vector, log(crossprod(A_matrix, t(theta_new))))
        return(loglikelihood)
    }
    else {
        print("There is something wrong with either the A_matrix or N_vector. One of them is NULL, but the other is not NULL.")
        return(NA)
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
