\name{log_likelihood_model1}
\alias{log_likelihood_model1}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Calculating the loglikelihood under model 1
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function calculates the loglikelihood under model 1, where model 1 is defined as the gene shows differential expression, but its alternative isoforms do not show differential expression among all the samples in the study. For a detailed description of model 1 and the fomular for the loglikelihood function, please see the reference.
}
\usage{
log_likelihood_model1(A_matrix, N_vector, W_vector, theta, tau)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{A_matrix}{
%%     ~~Describe \code{A_matrix} here~~
The sampling rate matrix under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling rate matrix (A matrix) of the kth sample.
}
  \item{N_vector}{
%%     ~~Describe \code{N_vector} here~~
The read counts vector under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the read counts vector (N vector) of the kth sample.
}
  \item{W_vector}{
%%     ~~Describe \code{W_vector} here~~
The sampling-rate row-sum vector under model 1, which is a list of length K (K is the number of samples in the study). The kth element in this list is the sampling-rate row-sum vector (W vector) of the kth sample.
}
  \item{theta}{
%%     ~~Describe \code{theta} here~~
The basic isoform abundance vector under model 1.
}
  \item{tau}{
%%     ~~Describe \code{tau} here~~
The isoform abundance ratio vector under model 1.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns either a numerical value or a numerical vector, depends on theta. If theta is a vector, then this function returns a numerical value. If theta is a matrix, for example, theta might be an importance sample for calculating confidence intervals under model 1. In this case, theta is a N*I matrix, where N is the number of samples and I is the number of isoforms of the gene, then this function return a vector of length N.
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#the following is a toy example adopt from reference [2]. In this toy example, we assumme there are two conditions, where condition 1 is the real data for the "Rnpep" gene as describes in section 5.1 of reference [2], while condition 2 is a hypothesized condition and it has the total reads exactly the same as condition 1 and read counts for "Rnpep" gene is twice as condition 1. Therefore we should expect the isoform abundance ratio vector (tau) to be ratio=(0.33, 0.67).

A1=matrix( c(4242, 296, 0, 4242, 0, 62)*2762428/1e9, nrow=2, byrow=T)#this is the sampling rate matrix of contion 1
A2=A1 #since the total reads of condition 2 is the same as condition 1, the sampling rate matrix of condtion 2 is also the same as condtion 1
A_matrix = list(A1, A2)

N1=c(216, 10, 0)#this is the read count vector for Rnpep in condtion 1
N2=c(432, 20, 0)#the read count vector for Rnpep in condtion 2 is twice as that in condition 1
N_vector = list(N1, N2)

W1=c(12.53590, 11.88949)#this is the W vector of contion 1
W2=W1#since sampling rate matrix of condition 2 is the same as condition 1, the W vector of condtion 2 is also the same as condtion 1
W_vector = list(W1, W2)

theta = c(46.41, 8.10)#this is the basic isoform abundance vector (theta) under model 1, which can be computed by calling the function em_model1.

tau = c(0.333, 0.667)#this is the isoform abundance ratio vector (tau) under model 1, which can be computed by calling the function em_model1.

loglikelihood = log_likelihood_model1(A_matrix, N_vector, W_vector, theta, tau)
loglikelihood
#the result should be 3185.209

## The function is currently defined as
function (A_matrix, N_vector, W_vector, theta, tau) 
{
    K_conditions = length(W_vector)
    dimention_theta = length(W_vector[[1]])
    theta = matrix(as.matrix(theta), ncol = dimention_theta)
    tau = matrix(as.matrix(tau), ncol = K_conditions)
    nrow_theta = dim(theta)[2]
    N_vector_temp = unlist(lapply(N_vector, na.exclude))
    A_matrix_temp = do.call(cbind, lapply(A_matrix, na.exclude))
    if (is.logical(A_matrix_temp) && is.logical(N_vector_temp)) {
        loglikelihood_m1 = rep(0, times = nrow_theta)
    }
    else if (is.logical(A_matrix_temp) == F && is.logical(N_vector_temp) == 
        F) {
        epsilon = 1e-10
        theta_new = theta + epsilon
        tau_new = tau + epsilon
        loglikelihood_m1_K_conditions = list()
        for (k in 1:K_conditions) {
            if (any(is.na(A_matrix[[k]])) == F && any(is.na(N_vector[[k]])) == 
                F) {
                loglikelihood_m1_K_conditions[[k]] = log(tau[, 
                  k]) * sum(N_vector[[k]]) + crossprod(N_vector[[k]], 
                  log(crossprod(A_matrix[[k]], t(theta_new)))) - 
                  tau[, k] * crossprod(W_vector[[k]], t(theta_new))
            }
            else if ((any(is.na(A_matrix[[k]])) == T && any(is.na(N_vector[[k]])) == 
                F) || (any(is.na(A_matrix[[k]])) == F && any(is.na(N_vector[[k]]) == 
                T))) {
                print(paste("Under condition", k))
                print("There is something wrong with either the A_matrix or N_vector. One of them is NULL, but the other is not NULL.")
                loglikelihood_m1 = NA
                return(loglikelihood_m1)
            }
        }
        loglikelihood_m1_matrix_form = do.call(rbind, loglikelihood_m1_K_conditions)
        loglikelihood_m1 = colSums(loglikelihood_m1_matrix_form)
        return(loglikelihood_m1)
    }
    else {
        print("There is something wrong with either the A_matrix or N_vector. One of them is NULL, but the other is not NULL.")
        loglikelihood_m1 = NA
        return(loglikelihood_m1)
    }
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
