\name{merge_file}
\alias{merge_file}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Merge the files read from rseq output files to an R list.
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function merges a list of the ".sampling_rates" files from rseq output into an R list. The list can be used as input for the "isoform_estimation" function to calculate the maximum likelihood estimation (MLE) of isoform abundance and perform statistical inference on isoform differential expression.
}
\usage{
merge_file(list_K_files, condition_names)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{list_K_files}{
%%     ~~Describe \code{list_K_files} here~~
This is a list containing K elements, where K is the number of RNA-seq samples in the study. Each element is the result returned from calling the "read_file" function.
}
  \item{condition_names}{
%%     ~~Describe \code{condition_names} here~~
This is a character vector of length K (K is the number of RNA-seq samples in the study), and each value in the vector is the name of the condition of the rseq output file, which should correspond to the element in "list_K_files". If the user does not specify this input value, the program will rank the condition numbers according to the input order by the user. 
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list. Each element in the list correspond to each gene in rseq output files, which is also a list contains the following items of the gene:
\item{gene_name}{the name of the gene.}
\item{isoform_names}{the names of all its alternative isoforms of the gene.}
\item{I}{the number of the alternative isoforms of the gene.}
\item{J}{This is a vector of length K, where K is the number of RNA-seq samples in the study. The kth element is the number of unique reads (J) of the gene in the kth RNA-seq sample.}
\item{A_matrix}{This is a list of length K, where K is the number of RNA-seq samples in the study. The kth element is the sampling rate matrix (A_matrix) of the gene in the kth RNA-seq sample.}
\item{N_vector}{This is a list of length K, where K is the number of RNA-seq samples in the study. The kth element is the read counts vector (N_vector) of the gene in the kth RNA-seq sample.}
\item{W_vector}{This is a list of length K, where K is the number of RNA-seq samples in the study. The kth element is the sampling-rate row-sum vector (W_vector) of the gene in the kth RNA-seq sample.}
}
\references{
%% ~put references to the literature/web site here ~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

#First, the user will need to call the function "read_file" to read the ".sampling_rates" files into R list objects:
file1=read_file("path to the .sampling_rates file of rseq output of sample 1")
file2=read_file("path to the .sampling_rates file of rseq output of sample 2")

#Second, the user will need to put all the lists generated in the above step into a list:
list_K_conditions=list(file1, file2, ...)

#Third, the user can call this function to generate a list containing all the K conditions. The condition_names is optional by the user:
list_all_conditions = merge_file(list_K_conditions, condition_names=c("adipose", "brain",...))

## The function is currently defined as
function (list_K_files, condition_names) 
{
    K_conditions = length(list_K_files)
    if (missing(condition_names)) {
        print("The user did not specify condition/sample names. The program will rank the condition numbers according to the input order by the user.")
        condition_names = NA
        for (k in 1:K_conditions) {
            condition_names[k] = paste("condition_", k, sep = "")
        }
    }
    num_genes = list_K_files[[1]]$number_genes
    final_result = list()
    for (num_iter in 1:num_genes) {
        gene_name = list_K_files[[1]][[num_iter]]$gene_name
        isoform_names = list_K_files[[1]][[num_iter]]$isoform_names
        I = list_K_files[[1]][[num_iter]]$I
        J = NA
        A_matrix = list()
        N_vector = list()
        W_vector = list()
        for (k in 1:K_conditions) {
            J[k] = list_K_files[[k]][[num_iter]]$J
            A_matrix[[condition_names[k]]] = list_K_files[[k]][[num_iter]]$A_matrix
            N_vector[[condition_names[k]]] = list_K_files[[k]][[num_iter]]$N_vector
            W_vector[[condition_names[k]]] = list_K_files[[k]][[num_iter]]$W_vector
        }
        gene = list(gene_name = gene_name, isoform_names = isoform_names, 
            I = I, J = J, A_matrix = A_matrix, N_vector = N_vector, 
            W_vector = W_vector)
        final_result[[gene_name]] = gene
    }
    return(final_result)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
