\name{rSeqDiff-package}
\alias{rSeqDiff-package}
\alias{rSeqDiff}
\docType{package}
\title{
What the package does (short line)
~~ package title ~~
Estimating and Inferring Gene Differential Expression and Differential Splicing for Multi-condition RNA-seq Data
}
\description{
More about what it does (maybe more than one line)
~~ A concise (1-5 lines) description of the package ~~
This R package performs statistical inference on whether there is differential isoform expression in multi-sample RNA-seq data, and calculates the maximum likelihood estimation (MLE) of the isoform abundance. 
}
\details{
\tabular{ll}{
Package: \tab rDiff\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2013-04-01\cr
License: \tab Anyone can use the source codes and documents of this R package free of charge for non-commercial use. For commercial use, please contact the authors.\cr
}
~~ An overview of how to use the package, including the most important ~~
~~ functions ~~
This R package performs statistical inference on whether there is differential isoform expression in multi-sample RNA-seq data, and calculates the maximum likelihood estimation (MLE) of the isoform abundance. Before using the package, the user should have some background knowledge in alternative splicing and RNA-seq, and we recommend the user to go over the references. Also the user need to know how to run rSeq (a set of software tools for RNA-Seq data analysis written by Hui Jiang and colleagues of Wing Wong's Lab) to generate the files that are used as input for this package. 

To use the package, the user will first need to run "expression_analysis" in rSeq to generate the ".sampling_rates" files for each RNA-seq sample. Then the user will need to call the function "read_file" to read the ".sampling_rates" files into R list objects. The following is an example:
file1=read_file("path to the .sampling_rates file of rseq output of sample 1")
file2=read_file("path to the .sampling_rates file of rseq output of sample 2")
...
Third, the user will need to put all the lists generated in the second step into a list:
list_K_conditions=list(file1, file2, ...)

Fourth, the user will need to call the "isoform_estimation" function and specify the "condition_names" and "CI" options based on the goal of study:
result=isoform_estimation(list_K_conditions, condition_names=c("brain", "kidney",...), CI=T)
#If the user doesn't give the condition_names, the default is "conditon_1" ,"condition_2"...
#The default option for CI is "CI=F", where the program won't compute the 95% confidence intervals for the the isoform abundance and the gene abundance.
#If the user asks "CI=T", the program will compute the 95% confidence intervals for the the isoform abundance and the gene abundance.

The "result" is an R list, and the length of the list is the number of genes in the study. Each element in the list is the estimation and inference for each gene in the study, which is also a list containing the following two lists:
\item{MLE_under_each_model}
{this is a list containing the maximum likelihood estimation (MLE) of the isoform abundance and gene abundance and the loglikelihood of the MLE under each of the three models(see the "description" above for what the three models are, and the reference for details).It contains the following entries:
\item{Model0_MLE}{contains MLE of the isoform abundance and gene abundance and the loglikelihood of the MLE under model 0.}
\item{Model1_MLE}{contains MLE of the isoform abundance and gene abundance and the loglikelihood of the MLE under model 1.}
\item{Model2_MLE}{contains MLE of the isoform abundance and gene abundance and the loglikelihood of the MLE under model 2.}
}

\item{OPT_model_estimation}
{this is a list containing estimation of the isoform abundance and gene abundance under the optimum model (which is selected by likelihood ratio test). It contains the following entries:
\item{opt_model}{tells you which model is the optimum model selected by the likelihood ratio test, it is either model 0, model 1 or model 2.}
\item{p_value}{the p-values of the likelihood ratio test.}
\item{MLE}{the MLE of the isoform abundance and gene abundance and the loglikelihood of the MLE under the optimum model.}
\item{CI_estimation}{if the user specifies 'CI=TRUE', then this value will be computed. It contains the 95% confidence intervals for the isoform abundance and the gene abundance of each condition under the optimum model.}
}
}
\author{
Yang Shi and Hui Jiang

Maintainer:  Yang Shi <shyboy@umich.edu> and Hui Jiang <jianghui@umich.edu>
~~ The author and/or maintainer of the package ~~
}
\references{
~~ Literature or other references for background information ~~
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8): 1026-1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
