\name{read_file}
\alias{read_file}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
Read the ".sampling_rates" output file of rseq to an R list.
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
This function reads the ".sampling_rates" output file of rseq to an R list. Each element in the list corresponds to each gene in rseq output files.
}
\usage{
read_file(file)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{file}{
%%     ~~Describe \code{file} here~~
this is the path to the ".sampling_rates" output file of rseq.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
This function returns a list. Each element in the list correspond to each gene in rseq output files, which is also a list contains the following items of the gene:
\item{gene_name}{the name of the gene.}
\item{isoform_names}{the names of all its alternative isoforms of the gene.}
\item{I}{the number of the alternative isoforms of the gene.}
\item{J}{the number of unique reads of the gene.}
\item{A_matrix}{the sampling rate matrix of the gene.}
\item{N_vector}{the read counts vector of the gene.}
\item{W_vector}{the sampling-rate row-sum vector for the gene.}
The last element of the list is the number of total genes.
}
\references{
Jiang, H., Wong, W.H. (2009) Statistical Inferences for Isoform Expression in RNA-Seq, Bioinformatics, 25(8), 1026C1032. 

Salzman, J., Jiang, H., Wong, W. H. (2011) Statistical Modeling of RNA-Seq Data, Statistical Science, 26 (1): 62-83.
}
\author{
%%  ~~who you are~~
Hui Jiang and Yang Shi
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

file1 = read_file(path to the ".sampling_rates" output file of rseq of condition 1)
file2 = read_file(path to the ".sampling_rates" output file of rseq of condition 2)
...

## The function is currently defined as
function (file) 
{
    text = readLines(file)
    stringsplit = strsplit(text, "\t")
    J_lines = NA
    num_iter = 0
    lines_skip = 0
    final_result = list()
    while (!is.null(stringsplit[lines_skip + 1][[1]])) {
        num_iter = num_iter + 1
        gene_name = stringsplit[[lines_skip + 1]][1]
        I = as.numeric(stringsplit[[lines_skip + 1]][2])
        J_lines[num_iter] = as.numeric(stringsplit[[lines_skip + 
            1]][3])
        J = J_lines[num_iter]
        isoform_names = stringsplit[[lines_skip + 2]]
        temp_number_vector = as.numeric(unlist(stringsplit[(lines_skip + 
            3):(lines_skip + J + 3)]))
        temp_number_matrix = matrix(c(temp_number_vector, 0), 
            nrow = I + 1, ncol = J + 1)
        if (J == 0) {
            A_matrix = NA
            N_vector = NA
        }
        else {
            A_matrix = as.matrix(temp_number_matrix[1:I, 1:J])
            N_vector = temp_number_matrix[I + 1, 1:J]
        }
        W_vector = temp_number_matrix[1:I, J + 1]
        gene = list(gene_name = gene_name, isoform_names = isoform_names, 
            I = I, J = J, A_matrix = A_matrix, N_vector = N_vector, 
            W_vector = W_vector)
        final_result[[gene_name]] = gene
        lines_skip = sum(J_lines[0:num_iter]) + 3 * num_iter
    }
    num_genes = num_iter
    final_result[["number_genes"]] = num_genes
    return(final_result)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
